// jquery.tweet.js - See http://tweet.seaofclouds.com/ or https://github.com/seaofclouds/tweet for more info
// Copyright (c) 2008-2012 Todd Matthews & Steve Purcell
// Licensed under the MIT (http://www.opensource.org/licenses/mit-license.php)

// Modified by Stan Scates for https://github.com/StanScates/Tweet.js-Mod

/* Copyright (c) 2013 Stan Scates
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

"use strict";

(function(d){"function"===typeof define&&define.amd?define(["jquery"],d):d(jQuery)})(function(d){d.fn.tweet=function(m){function f(b,a){if("string"===typeof b){var c=b,d;for(d in a){var f=a[d];c=c.replace(new RegExp("{"+d+"}","g"),null===f?"":f)}return c}return b(a)}function h(b,a){return function(){var c=[];this.each(function(){c.push(this.replace(b,a))});return d(c)}}function n(b,a){return b.replace(l,function(b){for(var c=/^[a-z]+:/i.test(b)?b:"http://"+b,d=0;d<a.length;++d){var e=a[d];if(e.url==
c&&e.expanded_url){c=e.expanded_url;b=e.display_url;break}}return'<a href="'+c.replace(/</g,"&lt;").replace(/>/g,"^&gt;")+'">'+b.replace(/</g,"&lt;").replace(/>/g,"^&gt;")+"</a>"})}function p(b){var a=parseInt(((1<arguments.length?arguments[1]:new Date).getTime()-b)/1E3,10);return 1>a?"just now":60>a?a+" seconds ago":120>a?"about a minute ago":2700>a?"about "+parseInt(a/60,10).toString()+" minutes ago":7200>a?"about an hour ago":86400>a?"about "+parseInt(a/3600,10).toString()+" hours ago":172800>
a?"about a day ago":"about "+parseInt(a/86400,10).toString()+" days ago"}function q(){var c=null===b.fetch?b.count:b.fetch,a={include_entities:1};if(b.list)return{host:b.twitter_api_url,url:"/1.1/lists/statuses.json",parameters:d.extend({},a,{list_id:b.list_id,slug:b.list,owner_screen_name:b.username,page:b.page,count:c,include_rts:b.retweets?1:0})};if(b.favorites)return{host:b.twitter_api_url,url:"/1.1/favorites/list.json",parameters:d.extend({},a,{list_id:b.list_id,screen_name:b.username,page:b.page,
count:c})};if(null===b.query&&1===b.username.length)return{host:b.twitter_api_url,url:"/1.1/statuses/user_timeline.json",parameters:d.extend({},a,{screen_name:b.username,page:b.page,count:c,include_rts:b.retweets?1:0})};var e=b.query||"from:"+b.username.join(" OR from:");return{host:b.twitter_search_url,url:"/search.json",parameters:d.extend({},a,{page:b.page,q:e,rpp:c})}}function k(b,a){return a?"user"in b?b.user.profile_image_url_https:k(b,!1).replace(/^http:\/\/[a-z0-9]{1,3}\.twimg\.com\//,"https://s3.amazonaws.com/twitter_production/"):
b.profile_image_url||b.user.profile_image_url}function r(c){var a={};a.item=c;a.source=c.source;a.name=c.from_user_name||c.user.name;a.screen_name=c.from_user||c.user.screen_name;a.avatar_size=b.avatar_size;a.avatar_url=k(c,"https:"===document.location.protocol);a.retweet="undefined"!=typeof c.retweeted_status;a.tweet_time=Date.parse(c.created_at.replace(/^([a-z]{3})( [a-z]{3} \d\d?)(.*)( \d{4})$/i,"$1,$2$4$3"));if("auto"==b.join_text){var e=c.text;e=e.match(/^(@([A-Za-z0-9-_]+)) .*/i)?b.auto_join_text_reply:
e.match(l)?b.auto_join_text_url:e.match(/^((\w+ed)|just) .*/im)?b.auto_join_text_ed:e.match(/^(\w*ing) .*/i)?b.auto_join_text_ing:b.auto_join_text_default}else e=b.join_text;a.join_text=e;a.tweet_id=c.id_str;a.twitter_base="https://"+b.twitter_url+"/";a.user_url=a.twitter_base+a.screen_name;a.tweet_url=a.user_url+"/status/"+a.tweet_id;a.reply_url=a.twitter_base+"intent/tweet?in_reply_to="+a.tweet_id;a.retweet_url=a.twitter_base+"intent/retweet?tweet_id="+a.tweet_id;a.favorite_url=a.twitter_base+"intent/favorite?tweet_id="+
a.tweet_id;a.retweeted_screen_name=a.retweet&&c.retweeted_status.user.screen_name;a.tweet_relative_time=p(a.tweet_time);a.entities=c.entities?(c.entities.urls||[]).concat(c.entities.media||[]):[];a.tweet_raw_text=a.retweet?"RT @"+a.retweeted_screen_name+" "+c.retweeted_status.text:c.text;a.tweet_text=d([n(a.tweet_raw_text,a.entities)]).linkUser().linkHash()[0];a.tweet_text_fancy=d([a.tweet_text]).makeHeart()[0];a.user=f('<a class="tweet_user" href="{user_url}" target="_blank">@{screen_name}</a>',
a);a.author_screen_name=f('<span class="tweet_screen_name">{screen_name}</span>',a);a.join=b.join_text?f(' <span class="tweet_join">{join_text}</span> ',a):" ";a.avatar=a.avatar_size?f('<a class="tweet_avatar" href="{user_url}" target="_blank"><img src="{avatar_url}" height="{avatar_size}" width="{avatar_size}" alt="{screen_name}\'s avatar" title="{screen_name}" border="0"/></a>',a):"";a.time=f('<span class="tweet_time"><a href="{tweet_url}" title="view tweet on twitter" target="_blank">{tweet_relative_time}</a></span>',
a);a.brand=f('<a class="tweet_brand" href="{tweet_url}" title="view tweet on twitter" target="_blank"></a>',a);a.text=f('<span class="tweet_text">{tweet_text_fancy}</span>',a);a.reply_action=f('<a class="tweet_action tweet_reply" href="{reply_url}">reply</a>',a);a.retweet_action=f('<a class="tweet_action tweet_retweet" href="{retweet_url}">retweet</a>',a);a.favorite_action=f('<a class="tweet_action tweet_favorite" href="{favorite_url}">favorite</a>',a);return a}var b=d.extend({modpath:"/twitter/",
username:null,list_id:null,list:null,favorites:!1,query:null,avatar_size:null,count:3,fetch:null,page:1,retweets:!0,intro_text:null,outro_text:null,join_text:null,auto_join_text_default:"i said,",auto_join_text_ed:"i",auto_join_text_ing:"i am",auto_join_text_reply:"i replied to",auto_join_text_url:"i was looking at",loading_text:null,refresh_interval:null,twitter_url:"twitter.com",twitter_api_url:"api.twitter.com",twitter_search_url:"search.twitter.com",template:"{avatar}{time}{join}{text}",comparator:function(b,
a){return a.tweet_time-b.tweet_time},filter:function(b){return!0}},m),l=/\b((?:[a-z][\w\-]+:(?:\/{1,3}|[a-z0-9%])|www\d{0,3}[.]|[a-z0-9.\-]+[.][a-z]{2,4}\/)(?:[^\s()<>]+|\(([^\s()<>]+|(\([^\s()<>]+\)))*\))+(?:\(([^\s()<>]+|(\([^\s()<>]+\)))*\)|[^\s`!()\[\]{};:'".,<>?\u00ab\u00bb\u201c\u201d\u2018\u2019]))/gi;d.extend({tweet:{t:f}});d.fn.extend({linkUser:h(/(^|[\W])@(\w+)/gi,'$1<span class="at">@</span><a href="http://'+b.twitter_url+'/$2">$2</a>'),linkHash:h(/(?:^| )[#]+([\w\u00c0-\u00d6\u00d8-\u00f6\u00f8-\u00ff\u0600-\u06ff]+)/gi,
' <a href="http://'+b.twitter_search_url+"/search?q=&tag=$1&lang=all"+(b.username&&1==b.username.length&&!b.list?"&from="+b.username.join("%2BOR%2B"):"")+'" class="tweet_hashtag">#$1</a>'),makeHeart:h(/(&lt;)+[3]/gi,"<tt class='heart'>&#x2665;</tt>")});return this.each(function(c,a){var e=d('<ul class="tweet_list">'),h='<p class="tweet_intro">'+b.intro_text+"</p>",l='<p class="tweet_outro">'+b.outro_text+"</p>",k=d('<p class="loading">'+b.loading_text+"</p>");b.username&&"string"==typeof b.username&&
(b.username=[b.username]);d(a).unbind("tweet:load").bind("tweet:load",function(){b.loading_text&&d(a).empty().append(k);d.ajax({dataType:"json",type:"post",async:!1,url:b.modpath||"/twitter/",data:{request:q(),action:"emd_twitter_feed"},success:function(c,k){if(c){c.message&&console.log(c.message);var g=c.response;d(a).empty().append(e);b.intro_text&&e.before(h);e.empty();if(g){var m=void 0!==g.statuses?g.statuses:void 0!==g.results?g.results:g;void 0!==g.errors?(e.remove(),d(a).append("<p>The tweets can not be retrieved: "+
g.errors[0].message+"</p>")):(g=d.map(m,r),g=d.grep(g,b.filter).sort(b.comparator).slice(0,b.count),e.append(d.map(g,function(a){return"<li>"+f(b.template,a)+"</li>"}).join("")).children("li:first").addClass("tweet_first").end().children("li:odd").addClass("tweet_even").end().children("li:even").addClass("tweet_odd"),b.outro_text&&e.after(l),d(a).trigger("loaded").trigger(g?"empty":"full"),b.refresh_interval&&window.setTimeout(function(){d(a).trigger("tweet:load")},1E3*b.refresh_interval))}else e.remove(),
d(a).append("<p>The tweets can not be retrieved.</p>")}}})}).trigger("tweet:load")})}});